diff --git a/rules.mk b/rules.mk
index 949bfb27e853b7e9242b2cdabad77743e2732b31..a79e20dfa42e5c345f2048545cedde040a93784e 100644
--- a/rules.mk
+++ b/rules.mk
@@ -269,6 +269,7 @@ else
     NM="$(TARGET_CROSS)nm" \
     STRIP="$(STRIP)" \
     STRIP_KMOD="$(SCRIPT_DIR)/strip-kmod.sh" \
+    PATCHELF="$(STAGING_DIR_HOST)/bin/patchelf" \
     $(SCRIPT_DIR)/rstrip.sh
 endif
 
diff --git a/scripts/rstrip.sh b/scripts/rstrip.sh
index 4665ff5559c99c90a5b88eab9877c50d48ef62e7..4e4232db60d6b67689c70ca36568d7790b006714 100755
--- a/scripts/rstrip.sh
+++ b/scripts/rstrip.sh
@@ -25,11 +25,21 @@ find $TARGETS -type f -a -exec file {} \; | \
 (
   IFS=":"
   while read F S; do
-    echo "$SELF: $F:$S"
+    echo "$SELF: $F: $S"
 	[ "${S}" = "relocatable" ] && {
 		eval "$STRIP_KMOD $F"
 	} || {
 		b=$(stat -c '%a' $F)
+		[ -z "$PATCHELF" ] || [ -z "$TOPDIR" ] || {
+			old_rpath="$($PATCHELF --print-rpath $F)"; new_rpath=""
+			for path in $old_rpath; do
+				case "$path" in
+					/lib/[^/]*|/usr/lib/[^/]*|\$ORIGIN/*) new_rpath="${new_rpath:+$new_rpath:}$path" ;;
+					*) echo "$SELF: $F: removing rpath $path" ;;
+				esac
+			done
+			[ "$new_rpath" = "$old_rpath" ] || $PATCHELF --set-rpath "$new_rpath" $F
+		}
 		eval "$STRIP $F"
 		a=$(stat -c '%a' $F)
 		[ "$a" = "$b" ] || chmod $b $F